<license>
  (c) 2010-present DEMOS plan GmbH.

  This file is part of the package demosplan,
  for more information see the license file.

  All rights reserved
</license>

<template>
  <div>
    <dp-inline-notification
      v-if="transformedStatements.length === 0"
      :message="Translator.trans('statement.list.empty')"
      type="info" />
    <draggable
      v-else
      v-model="transformedStatements"
      class="space-stack-m"
      data-cy="publicStatementList"
      :disabled="hasPermission('feature_statements_manualsort') === false"
      @change="saveSort">
      <dp-public-statement
        v-for="(statement, idx) in transformedStatements"
        :key="idx"
        v-bind="statement"
        @open-map-modal="openMapModal"
        @open-statement-modal-from-list="(id) => $parent.$emit('open-statement-modal-from-list', id)"
        :menu-items-generator="menuItemCallback"
        :procedure-id="procedureId"
        :show-author="showAuthor"
        :show-checkbox="showCheckbox" />
    </draggable>
    <dp-map-modal
      ref="mapModal"
      :procedure-id="procedureId" />
  </div>
</template>

<script>
import { DpInlineNotification, dpSelectAllMixin, getFileInfo } from '@demos-europe/demosplan-ui'
import dayjs from 'dayjs'
import DpMapModal from '@DpJs/components/statement/assessmentTable/DpMapModal'
import DpPublicStatement from './DpPublicStatement'
import draggable from 'vuedraggable'
import { generateMenuItems } from './menuItems'

const editPermissions = {
  draft: 'feature_statements_draft_edit',
  released: 'feature_statements_released_edit',
  released_group: 'feature_statements_released_group_edit',
  final_group: 'feature_statements_final_group_edit'
}

const deletePermissions = {
  draft: 'feature_statements_draft_delete',
  released: 'feature_statements_released_delete',
  released_group: 'feature_statements_released_group_delete',
  final_group: 'feature_statements_final_group_delete'
}

const emailPermissions = {
  draft: 'feature_statements_draft_email',
  released: 'feature_statements_released_email',
  released_group: 'feature_statements_released_group_email',
  final_group: 'feature_statements_final_email' // Feature name is not the same as target name
}

export default {
  name: 'DpPublicStatementList',

  components: {
    DpInlineNotification,
    DpMapModal,
    DpPublicStatement,
    draggable
  },

  mixins: [dpSelectAllMixin],

  props: {
    counties: {
      type: Array,
      required: false,
      default: () => ([])
    },

    procedureId: {
      type: String,
      required: true
    },

    showAuthor: {
      type: Boolean,
      required: false,
      default: false

    },

    showCheckbox: {
      type: Boolean,
      required: false,
      default: false
    },

    showDelete: {
      type: Boolean,
      required: false,
      default: false
    },

    showEdit: {
      type: Boolean,
      required: false,
      default: false
    },

    showEmail: {
      type: Boolean,
      required: false,
      default: false
    },

    showPdfDownload: {
      type: Boolean,
      default: false
    },

    showPublish: {
      type: Boolean,
      required: false,
      default: false
    },

    showReject: {
      type: Boolean,
      required: false,
      default: false
    },

    showVersions: {
      type: Boolean,
      required: false,
      default: false
    },

    statements: {
      type: Array,
      required: true
    },

    target: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      transformedStatements: this.transformStatements(this.statements)
    }
  },
  computed: {
    actionFields () {
      const fields = []
      if (hasPermission(editPermissions[this.target]) && this.showEdit) {
        fields.push('edit')
      }

      if (hasPermission(deletePermissions[this.target]) && this.showDelete) {
        fields.push('delete')
      }

      if (hasPermission('feature_statements_released_group_reject') && this.showReject) {
        fields.push('reject')
      }

      if (hasPermission(emailPermissions[this.target]) && this.showEmail) {
        fields.push('email')
      }

      if (hasPermission('feature_statements_public') && this.showPublish) {
        fields.push('publish')
      }

      if (hasPermission('feature_statements_draft_versions') && this.showVersions) {
        fields.push('versions')
      }

      if (this.showPdfDownload) {
        fields.push('pdf')
      }

      return fields
    },

    menuItemCallback () {
      return (id, elementId, paragraphId, isPublished) => generateMenuItems({
        fields: this.actionFields,
        target: this.target,
        procedureId: this.procedureId,
        id,
        elementId,
        paragraphId,
        isPublished
      })
    }
  },
  methods: {
    openMapModal (polygon) {
      this.$refs.mapModal.toggleModal(polygon)
    },

    saveSort () {
      document.querySelector('[data-flash-message]').innerText = Translator.trans('warning.sort.save')
      const container = document.querySelector('[data-flash-container]')
      container.classList.remove('flash-info')
      container.classList.remove('flash-warning')
      container.classList.add('flash-error')
    },

    transformStatement (statement) {
      const {
        createdDate,
        document,
        element,
        files,
        ident,
        paragraph,
        statementAttributes,
        number,
        uName,
        dName,
        oName,
        submittedDate,
        phase,
        polygon,
        elementId,
        paragraphId,
        showToAll,
        submitted,
        rejectedReason
      } = statement

      const attachments = files.map(f => getFileInfo(f))

      let county = {}
      if (hasPermission('field_statement_county')) {
        county = statementAttributes.county && this.counties.find(c => c.value === statementAttributes.county)
        county = { county: (county && county.label) || Translator.trans('notspecified') }
      }

      let priorityAreas = {}
      if (dplan.procedureStatementPriorityArea) {
        priorityAreas = { priorityAreas: statementAttributes.priorityAreaKey ? statementAttributes.priorityAreaKey : Translator.trans('notspecified') }
      }

      let statementDocument = (element && element.title) || ''
      statementDocument += document && document.title ? ` / ${document.title}` : ''

      const statementParagraph = (paragraph && paragraph.title) || Translator.trans('notspecified')
      const text = statement.text

      const transformedSubmitDate = submitted === false ? {} : { submittedDate: dayjs(submittedDate).format('DD.MM.YYYY HH:mm') }
      const transformedCreatedDate = dayjs(createdDate).format('DD.MM.YYYY HH:mm')

      const transformedPolygon = polygon === '' ? {} : JSON.parse(polygon)

      return {
        attachments,
        ...county,
        createdDate: transformedCreatedDate,
        department: dName,
        document: statementDocument,
        id: ident,
        organisation: oName,
        paragraph: statementParagraph,
        phase,
        polygon: transformedPolygon,
        ...priorityAreas,
        ...transformedSubmitDate,
        text,
        number,
        user: uName,
        elementId,
        paragraphId,
        isPublished: showToAll,
        rejectedReason
      }
    },

    transformStatements (statements) {
      return statements.map(s => this.transformStatement(s))
    }
  }
}
</script>
